// Inclou deep sleep i emmagatzemament dels paràmetres OTAA

// #define DEPURACIO

/*
  Canvis fets a srq_sb_s2c02_11_fake_01_traientLoRa.ino :

  #include <Adafruit_Sensor.h>
  #include "Adafruit_BME680.h"
  Adafruit_BME680 bme;

  void vSetupBME680() {
  if (!bme.begin()) {
    Serial.println("Could not find a valid BME680 sensor, check wiring!");
    while (1);
  }

  // Set up oversampling and filter initialization
  bme.setTemperatureOversampling(BME680_OS_8X);
  bme.setHumidityOversampling(BME680_OS_2X);
  bme.setPressureOversampling(BME680_OS_4X);
  bme.setIIRFilterSize(BME680_FILTER_SIZE_3);
  bme.setGasHeater(320, 150); // 320*C for 150 ms;
  }

  void setup(){
    ...
    vSetupBME680();
  }

  void vGetSensorValues(int n_enR) {
    ...
        // if (bReadBME280(&fTc, &fTf, &fP, &fRH)) {
        if (bReadBME680(&fTc, &fGr, &fP, &fRH)) {
    ...
  }

  Canvis fets a srq_sb_s2c02_11_fake_00.ino :

  Per defecte els sensors venen programats a l'adreça 01 del ModBus. Per a canviar-ho s'ha de fer servir a Finestrots un d'aquests programes:
  http://electronics.cat/clients/siarq/s2c/sensor_3.9.exe
  http://electronics.cat/clients/siarq/s2c/RS485ControlV22.exe
  Vídeo d'ús (per als que no sabem xinès):
  http://electronics.cat/clients/siarq/s2c/VID_20180306_094431.mp4


  // #define MB_SENSOR_CO2 "040300000003"
  #define MB_SENSOR_CO2 "010300000003"

  Per adaptar-ho a l'aplicació de TTN Applications/siarq_s2c/Devices/fake_s2c_lab s'han canviat els valors de:
  static const u1_t PROGMEM APPEUI[8]
  static const u1_t PROGMEM DEVEUI[8]
  static const u1_t PROGMEM APPKEY[16]

  El control de lectura / escriptura a ModBus:

  pinMode(SSerialTxControl, OUTPUT); // hardwired to GPIO_5. In CAH is hardwired to GPIO_33

  Malgrat el comentari, el define ja era 33:

  #define SSerialTxControl 33

*/

#include <lmic.h>
#include <hal/hal.h>
#include <SPI.h>
#include "Wire.h"
#include <Adafruit_GFX.h>
//#include <Adafruit_SSD1306.h>

#define USING_WIFI

#if CONFIG_FREERTOS_UNICORE
#define ARDUINO_RUNNING_CORE 0
#else
#define ARDUINO_RUNNING_CORE 1
#endif

#define INTERVAL_MISSATGES_MQTT_EN_SEGONS 30

bool bLedBlancEnces = false, bMqttsConnectat;

#ifdef USING_WIFI
#include <WiFi.h>
#include "IoT-02_wifiMng.h"
#include "IoT-02_mqttCredentials.h"
#include "IoT-02_mqttTopics.h"
#include <PubSubClient.h>
#include <ESPmDNS.h>
WiFiClientSecure espClient;
PubSubClient client(espClient);
#define MAC_SIZE 15
char sMac[MAC_SIZE];
String sIP;
bool bConsultaWiFi = false;
bool bMacIpWifiConsultada = false;
#endif         /* USING_WIFI */

#define MINIMUM_DELAY_ALLOWING_MULTITASKING 50
#define BT_IO0 0

String sJson;

float fVector[6];

#define I2C_SDA 21
#define I2C_SCL 22

#include "IoT-02_oled.h"
SSD1306  display(0x3c, I2C_SDA, I2C_SCL);

#include <Adafruit_Sensor.h>
#include "Adafruit_BME680.h"
Adafruit_BME680 bme;

// This EUI must be in little-endian format, so least-significant-byte
// first. When copying an EUI from ttnctl output, this means to reverse
// the bytes. For TTN issued EUIs the last bytes should be 0xD5, 0xB3,
// 0x70.
// static const u1_t PROGMEM APPEUI[8] = { 0x61, 0x49, 0x02, 0xD0, 0x7E, 0xD5, 0xB3, 0x70 }; // dev-test-01
// static const u1_t PROGMEM APPEUI[8] = { 0xF0, 0x91, 0x01, 0xD0, 0x7E, 0xD5, 0xB3, 0x70 }; // santboi-03
static const u1_t PROGMEM APPEUI[8] = { 0x61, 0x49, 0x02, 0xD0, 0x7E, 0xD5, 0xB3, 0x70 }; // Applications/siarq_s2c/Devices/fake_s2c_lab
void os_getArtEui (u1_t* buf) {
  memcpy_P(buf, APPEUI, 8);
}

// This should also be in little endian format, see above.
// static const u1_t PROGMEM DEVEUI[8] = { 0x4A, 0xAE, 0x58, 0x9F, 0x03, 0xB6, 0xBB, 0x00 }; // dev-test-01
// static const u1_t PROGMEM DEVEUI[8] = { 0x8D, 0xE7, 0xD2, 0x6D, 0xEF, 0xBC, 0x33, 0x00 }; // santboi-03
static const u1_t PROGMEM DEVEUI[8] = { 0x6C, 0x20, 0x3B, 0x36, 0x44, 0xD0, 0x4C, 0x00 }; // Applications/siarq_s2c/Devices/fake_s2c_lab
void os_getDevEui (u1_t* buf) {
  memcpy_P(buf, DEVEUI, 8);
}

// This key should be in big endian format (or, since it is not really a
// number but a block of memory, endianness does not really apply). In
// practice, a key taken from ttnctl can be copied as-is.
// The key shown here is the semtech default key.
// static const u1_t PROGMEM APPKEY[16] = { 0x87, 0xE5, 0xB4, 0x85, 0x1F, 0x12, 0xAE, 0x5F, 0x87, 0xFD, 0xC4, 0x2C, 0x74, 0x3A, 0x0B, 0x90 }; // dev-test-01
// static const u1_t PROGMEM APPKEY[16] = { 0x9A, 0x05, 0xCE, 0x1B, 0xDB, 0x5E, 0x20, 0x24, 0x8C, 0x55, 0x86, 0x3C, 0xD8, 0x9C, 0x1E, 0x1F }; // santboi-03
static const u1_t PROGMEM APPKEY[16] = { 0x06, 0xA4, 0x72, 0x2C, 0x8A, 0x0B, 0x82, 0x06, 0x94, 0x7F, 0x22, 0x67, 0xD1, 0xA4, 0x8E, 0xD2 }; // Applications/siarq_s2c/Devices/fake_s2c_lab
void os_getDevKey (u1_t* buf) {
  memcpy_P(buf, APPKEY, 16);
}

RTC_DATA_ATTR u4_t RTC_LORAWAN_netid = 0;
RTC_DATA_ATTR devaddr_t RTC_LORAWAN_devaddr = 0;
RTC_DATA_ATTR u1_t RTC_LORAWAN_nwkKey[16];
RTC_DATA_ATTR u1_t RTC_LORAWAN_artKey[16];
RTC_DATA_ATTR u1_t RTC_LORAWAN_dn2Dr;
RTC_DATA_ATTR u1_t RTC_LORAWAN_dnConf;
RTC_DATA_ATTR u4_t RTC_LORAWAN_seqnoDn;
RTC_DATA_ATTR u4_t RTC_LORAWAN_seqnoUp = 0;
RTC_DATA_ATTR s1_t RTC_LORAWAN_adrTxPow;
RTC_DATA_ATTR s1_t RTC_LORAWAN_datarate;
RTC_DATA_ATTR u1_t RTC_LORAWAN_txChnl;
RTC_DATA_ATTR s2_t RTC_LORAWAN_adrAckReq;
RTC_DATA_ATTR u1_t RTC_LORAWAN_rx1DrOffset;
RTC_DATA_ATTR u1_t RTC_LORAWAN_rxDelay;
RTC_DATA_ATTR u4_t RTC_LORAWAN_channelFreq[MAX_CHANNELS];
RTC_DATA_ATTR u2_t RTC_LORAWAN_channelDrMap[MAX_CHANNELS];
RTC_DATA_ATTR u4_t RTC_LORAWAN_channelDlFreq[MAX_CHANNELS];
RTC_DATA_ATTR band_t RTC_LORAWAN_bands[MAX_BANDS];
RTC_DATA_ATTR u2_t RTC_LORAWAN_channelMap;
RTC_DATA_ATTR int bootCount = 0;

static uint8_t mydata[] = "Hello, world!";
static osjob_t sendjob;

// Schedule TX every this many seconds (might become longer due to duty
// cycle limitations).
const unsigned TX_INTERVAL = 60;
bool GOTO_DEEPSLEEP = false;

#define uS_TO_S_FACTOR 1000000 /* Conversion factor for micro seconds to seconds */
#define TIME_TO_SLEEP 10*60 /* Time ESP32 will go to sleep (in seconds) */

// Pin mapping
#define SCK_GPIO     5
#define MISO_GPIO   15
#define MOSI_GPIO   25
#define NSS_GPIO    18 /*16*/
#define RXTX_GPIO   LMIC_UNUSED_PIN
#define RESET_GPIO  14
#define DIO0_GPIO   26
#define DIO1_GPIO   13
#define DIO2_GPIO   12

const lmic_pinmap lmic_pins = {
  .nss = NSS_GPIO,
  .rxtx = RXTX_GPIO,
  .rst = RESET_GPIO,
  .dio = {DIO0_GPIO, DIO1_GPIO, DIO2_GPIO},
};

#define MAX_STR_LEN 50
#define LORA_DATA_LEN 33
#define TIMEOUT_ms  100

#ifndef SSerialTxControl
#define SSerialTxControl 33 /*RS485 Direction control*/
#define RS485Transmit HIGH
#define RS485Receive LOW
#endif

#define MB_SENSOR_PM "030300000002"
// #define MB_SENSOR_CO2 "040300000003"
#define MB_SENSOR_CO2 "010300000003"
#define MB_SENSOR_NOISE "050300000001"
#define MB_SENSOR_O3 "060300000003"
#define MB_SENSOR_NO2 "070300060001"
#define MB_SENSOR_SO2 "080300020001"

#define MB_SENSOR_T_1 "010300000002"
#define MB_SENSOR_T_2 "020300000002"
#define MB_SENSOR_T_3 "030300000002"
#define MB_SENSOR_T_4 "040300000002"

#define I2C_CONNECTED   0x02
#define PM_CONNECTED    0x04
#define CO2_CONNECTED   0x08
#define NOISE_CONNECTED 0x10
#define O3_CONNECTED    0x20
#define NO2_CONNECTED   0x40
#define SO2_CONNECTED   0x80

#define OLED_RESET          4 /* Not connected. It is used to compile. */
/*
  Adafruit_SSD1306 display(OLED_RESET);
  #if (SSD1306_LCDHEIGHT != 64)
  #error("Height incorrect, please fix Adafruit_SSD1306.h!");
  #endif
*/
#define ADDR_I2C_BME280 0x76

union uSI {
  byte by[2];
  short int nV;
};

union uLI {
  byte by[4];
  long int nV;
};

HardwareSerial modbusData(2);
unsigned char ucLastMbMsg[MAX_STR_LEN];
int nMbLastLen;
bool bMbAnswer;

byte bySensorsLoraData[33];

boolean bPressedButton(int nWhichOne) {
  if (digitalRead(nWhichOne))
    return false;
  return true;
}

#ifdef USING_WIFI
void vConnectingMqttsTask( void *pvParameters );


String ip2Str(IPAddress ip) {
  String s = "";
  for (int i = 0; i < 4; i++) {
    s += i  ? "." + String(ip[i]) : String(ip[i]);
  }
  return s;
}

void receivedCallback(char* topic, byte* payload, unsigned int length) {
  float fTc, fRH, fP, fAlt;

  String szTopic = String(topic), szPayload = "";
  Serial.print("Topic: ");
  Serial.println(topic);

  Serial.print("payload: ");
  for (int i = 0; i < length; i++) {
    Serial.print((char)payload[i]);
    szPayload += (char)payload[i];
  }
  Serial.println();
  //Serial.print("Topic: "); Serial.println(szTopic);
  if (szTopic == TOPIC_REQUEST_MAC) {
    if (bPressedButton(BT_IO0)) {
      //szGetMac().toCharArray(sMac, MAC_SIZE);
      Serial.print(TOPIC_MAC); Serial.print(" : "); Serial.println(sMac);
      client.publish(TOPIC_MAC, sMac);
    }
  }
  /*
    if (szTopic == String("/" + String(sMac) + TOPIC_REQUEST_CAL).c_str()) {
      bAutoCal_CO2 = true;
      Serial.println("Autocalibració del CO2");
      //myMHZ19.autoCalibration();
    }
  */
  if (szTopic == String("/" + String(sMac) + TOPIC_CHECK_WIFI).c_str()) {
    bConsultaWiFi = true;
    Serial.println("Rebut) Hi ha Wifi");
    //vPantallaHiHaWiFi();
  }

  if (szTopic == String("/" + String(sMac) + TOPIC_LED_W).c_str()) {
    bLedBlancEnces = true;
    Serial.println("Rebut) Petició d'encendre el led blanc");
    //vPantallaHiHaWiFi();
  }

}


void mqttconnect() {
  const TickType_t xDelay = 5000 / portTICK_PERIOD_MS; // 5 seconds

  /* Loop until reconnected */
  while (!client.connected()) {
    Serial.print("MQTT connecting ...");
    /* client ID */
    String clientId = "IoT-02_" + String(sMac); // <-------   Unique name in every device
    /* connect now */
    if (client.connect(clientId.c_str(), mqtt_user, mqtt_password)) {
      //if (client.connect(clientId.c_str())) {
      Serial.println("connected");
      /* subscribe topic */
      client.subscribe(TOPIC_REQUEST_MAC); // <-------   Subscription to MQTT(S) topic
      client.subscribe(String("/" + String(sMac) + TOPIC_LED_W).c_str());
      client.subscribe(String("/" + String(sMac) + TOPIC_LED_R).c_str());
      client.subscribe(String("/" + String(sMac) + TOPIC_LED_Y).c_str());
      client.subscribe(String("/" + String(sMac) + TOPIC_LED_G).c_str());
      client.subscribe(String("/" + String(sMac) + TOPIC_LATCHING_RELAY).c_str());
      client.subscribe(String("/" + String(sMac) + TOPIC_REQUEST_LATCHING_RELAY_STATE).c_str());
      client.subscribe(String("/" + String(sMac) + TOPIC_REQUEST_LDR).c_str());
      client.subscribe(String("/" + String(sMac) + TOPIC_REQUEST_T).c_str());
      client.subscribe(String("/" + String(sMac) + TOPIC_REQUEST_RH).c_str());
      client.subscribe(String("/" + String(sMac) + TOPIC_REQUEST_P).c_str());
      client.subscribe(String("/" + String(sMac) + TOPIC_REQUEST_ALT).c_str());
      client.subscribe(String("/" + String(sMac) + TOPIC_SMALL_TEXT).c_str());
      client.subscribe(String("/" + String(sMac) + TOPIC_MEDIUM_TEXT).c_str());
      client.subscribe(String("/" + String(sMac) + TOPIC_BIG_TEXT).c_str());
      client.subscribe(String("/" + String(sMac) + TOPIC_REQUEST_CAL).c_str());
      client.subscribe(String("/" + String(sMac) + TOPIC_CHECK_WIFI).c_str());
    } else {
      Serial.print("failed, status code =");
      Serial.print(client.state());
      Serial.println("try again in 5 seconds");
      /* Wait 5 seconds before retrying */
      //delay(5000);
      vTaskDelay(xDelay);
    }
  }
}

void vSetupMqtt() {
  /* set SSL/TLS certificate */
  espClient.setCACert(ca_cert);
  /* configure the MQTT server with IPaddress and port */
  client.setServer(mqtt_server, mqtt_port);
  /* this receivedCallback function will be invoked
    when client received subscribed topic */
  client.setCallback(receivedCallback);
}

void vReconnectWifiMqtt() {
  vSetupWifi();

  szGetMac().toCharArray(sMac, MAC_SIZE);
  /*
    Serial.println("");
    Serial.println("WiFi connected");
    Serial.println("IP address: ");
    Serial.println(WiFi.localIP());
  */
  vSetupMqtt();
  mqttconnect();

}

void vConnectingMqttsTask(void *parameter) {

  //Serial.println("0) vConnectingMqttsTask");

  for (;;) {
    if (WiFi.status() != WL_CONNECTED) {
      //Serial.println("1) vConnectingMqttsTask");
      bMqttsConnectat = false;
      sIP = "0.0.0.0";
      vReconnectWifiMqtt();
      if (WiFi.status() == WL_CONNECTED) {
        sIP = ip2Str(WiFi.localIP());
      }
      Serial.println("IP address: ");
      Serial.println(sIP);
    } else {
      if (client.connected()) {
        bMqttsConnectat = true;
        client.loop();
      } else {
        bMqttsConnectat = false;
        mqttconnect();
      }
    }

    /*
      if (WiFi.status() == WL_CONNECTED) {
       sIP = ip2Str(WiFi.localIP());
       szGetMac().toCharArray(sMac, MAC_SIZE);
      }
    */

    /*
      if (!client.connected())
      vReconnectWifiMqtt();
      else
      client.loop();
    */
    vTaskDelay(MINIMUM_DELAY_ALLOWING_MULTITASKING);
  }
  vTaskDelete(NULL); // There is an infinite loop before. This line will never be reached.
}

#endif         /* USING_WIFI */



void vShowReceivedData(unsigned char *ucLastRx, int nLen) {
#ifdef DEPURACIO
  Serial.println("Received data in hexadecimal:");
  for (int i = 0; i < nLen ; i++) {
    Serial.print(ucLastRx[i], HEX);
    Serial.print(" ");
  }
  Serial.println();
#endif
}

int nReceivingData(unsigned char *ucData, int nTimeOut_ms) {
  unsigned long ulTimeReceived, ulTimeFuncStarted = millis();
  boolean bReceiveUntilTimeout = false, bFinished = false;
  int i = 0;

  while (!bFinished) {
    if (!bReceiveUntilTimeout) {
      if (modbusData.available() > 0 )  {
        i = 0;
        ucData[i++] = modbusData.read();
        bReceiveUntilTimeout = true;
        ulTimeReceived = millis();
      } else {
        if (millis() - ulTimeFuncStarted >= nTimeOut_ms)      {
          bFinished = true;
        }
      }
    } else {
      if (modbusData.available() > 0)    {
        ucData[i++] = modbusData.read();
        ulTimeReceived = millis();
      } else {
        if (millis() - ulTimeReceived >= nTimeOut_ms)      {
          bReceiveUntilTimeout = false;
          bFinished = true;
        }
      }
    }
    if (i >= MAX_STR_LEN - 1)
      bFinished = true;
  }
  return i;
}

short int siBytes2shortInt(byte *b) {
  union uSI uB;

  uB.by[1] = b[0];
  uB.by[0] = b[1];

  return uB.nV;
}

long int liBytes2longInt(byte *b) {
  union uLI uW;

  uW.by[1] = b[0];
  uW.by[0] = b[1];
  uW.by[3] = b[2];
  uW.by[2] = b[3];

  return uW.nV;
}

void vPutInt16(short int n, byte* b, int nWhere) {
  union {
    short int n;
    byte b[2];
  } uInt16;
  int i;

  uInt16.n = n;
  for (i = 0 ; i < 2 ; i++) {
    b[nWhere + i] = uInt16.b[i];
  }
}
void modbusFlush()
{
  char t;

  while (modbusData.available() > 0)
  {
    t = modbusData.read();
  }
}

void vModeTxRxRS485(boolean bMode)
{
  digitalWrite(SSerialTxControl, bMode);
}

// Compute the MODBUS RTU CRC
// Adapted to Arduino from http://www.ccontrolsys.com/w/How_to_Compute_the_Modbus_RTU_Message_CRC
unsigned int uiModRTU_CRC(byte *buf, int len)
{
  unsigned int crc = 0xFFFF;

  for (int pos = 0; pos < len; pos++)
  {
    crc ^= (unsigned int)buf[pos]; // XOR byte into least sig. byte of crc

    for (int i = 8; i != 0; i--)
    { // Loop over each bit
      if ((crc & 0x0001) != 0)
      { // If the LSB is set
        crc >>= 1; // Shift right and XOR 0xA001
        crc ^= 0xA001;
      }
      else           // Else LSB is not set
        crc >>= 1; // Just shift right
    }
  }
  // Note, this number has low and high bytes swapped, so use it accordingly (or swap bytes)
  return crc;
}

void vModbusTx(unsigned char *uc, int nLen)
{
  int i;

  for (i = 0; i < nLen; i++)
  {
    ucLastMbMsg[i] = uc[i];
    // Serial.print(uc[i], HEX);
    // //Serial.print(uc[i], DEC);
    // Serial.print(" ");
  }
  // Serial.println();
  nMbLastLen = nLen;

  vModeTxRxRS485(RS485Transmit);
  delay(1);
  for (i = 0; i < nLen; i++)
  {
    modbusData.write(uc[i]);
  }
  delay(20); // 20 at 4800baus and 2 at 115200

  vModeTxRxRS485(RS485Receive);
  bMbAnswer = false;
  // uiMbTimeOut = millis() + TIMEOUT;
}

int str2hex(char *s)
{
  int x = 0;
  for (;;)
  {
    char c = *s;
    if (c >= '0' && c <= '9')
    {
      x *= 16;
      x += c - '0';
    }
    else if (c >= 'A' && c <= 'F')
    {
      x *= 16;
      x += (c - 'A') + 10;
    }
    else
      break;
    s++;
  }
  return x;
}

void vPeticioModBus(String sz)
{
  unsigned char ucSt[MAX_STR_LEN];
  String szSubStr;
  char charBuf[3];
  int i, nMida = sz.length() / 2;

#ifdef DEPURACIO
  Serial.println("Petició a ModBus:");
  Serial.println(sz);
#endif
  // Serial.print("Mida: ");
  // Serial.println(nMida);
  // str2hex
  for (i = 0; i < nMida; i++)
  {
    szSubStr = sz.substring(2 * i, 2 + 2 * i);
    szSubStr.toCharArray(charBuf, 3);
    ucSt[i] = str2hex(charBuf);
    // Serial.print("ucSt[");
    // Serial.print(i);
    // Serial.print("] = ");
    // Serial.println(ucSt[i], HEX);
  }
  unsigned int uiCRC = uiModRTU_CRC(ucSt, nMida);

  ucSt[nMida] = (byte)(uiCRC & 0xFF);
  ucSt[nMida + 1] = (byte)(uiCRC >> 8);

  vModbusTx(ucSt, nMida + 2);
  // szDarreraPeticio = sz;
}

bool bReadBME280(float *fTc, float *fTf, float *fP, float *fRH)
{
  unsigned int b1[24];
  unsigned int data[8];
  unsigned int dig_H1 = 0;
  for (int i = 0; i < 24; i++)
  {
    // Start I2C Transmission
    Wire.beginTransmission(ADDR_I2C_BME280);
    // Select data register
    Wire.write((136 + i));
    // Stop I2C Transmission
    Wire.endTransmission();

    // Request 1 byte of data
    Wire.requestFrom(ADDR_I2C_BME280, 1);

    // Read 24 bytes of data
    if (Wire.available() == 1)
    {
      b1[i] = Wire.read();
    } else
      return false;
  }

  // Convert the data
  // temp coefficients
  unsigned int dig_T1 = (b1[0] & 0xff) + ((b1[1] & 0xff) * 256);
  int dig_T2 = b1[2] + (b1[3] * 256);
  int dig_T3 = b1[4] + (b1[5] * 256);

  // pressure coefficients
  unsigned int dig_P1 = (b1[6] & 0xff) + ((b1[7] & 0xff) * 256);
  int dig_P2 = b1[8] + (b1[9] * 256);
  int dig_P3 = b1[10] + (b1[11] * 256);
  int dig_P4 = b1[12] + (b1[13] * 256);
  int dig_P5 = b1[14] + (b1[15] * 256);
  int dig_P6 = b1[16] + (b1[17] * 256);
  int dig_P7 = b1[18] + (b1[19] * 256);
  int dig_P8 = b1[20] + (b1[21] * 256);
  int dig_P9 = b1[22] + (b1[23] * 256);

  // Start I2C Transmission
  Wire.beginTransmission(ADDR_I2C_BME280);
  // Select data register
  Wire.write(161);
  // Stop I2C Transmission
  Wire.endTransmission();

  // Request 1 byte of data
  Wire.requestFrom(ADDR_I2C_BME280, 1);

  // Read 1 byte of data
  if (Wire.available() == 1)
  {
    dig_H1 = Wire.read();
  }

  for (int i = 0; i < 7; i++)
  {
    // Start I2C Transmission
    Wire.beginTransmission(ADDR_I2C_BME280);
    // Select data register
    Wire.write((225 + i));
    // Stop I2C Transmission
    Wire.endTransmission();

    // Request 1 byte of data
    Wire.requestFrom(ADDR_I2C_BME280, 1);

    // Read 7 bytes of data
    if (Wire.available() == 1)
    {
      b1[i] = Wire.read();
    }
  }

  // Convert the data
  // humidity coefficients
  int dig_H2 = b1[0] + (b1[1] * 256);
  unsigned int dig_H3 = b1[2] & 0xFF;
  int dig_H4 = (b1[3] * 16) + (b1[4] & 0xF);
  int dig_H5 = (b1[4] / 16) + (b1[5] * 16);
  int dig_H6 = b1[6];

  // Start I2C Transmission
  Wire.beginTransmission(ADDR_I2C_BME280);
  // Select control humidity register
  Wire.write(0xF2);
  // Humidity over sampling rate = 1
  Wire.write(0x01);
  // Stop I2C Transmission
  Wire.endTransmission();

  // Start I2C Transmission
  Wire.beginTransmission(ADDR_I2C_BME280);
  // Select control measurement register
  Wire.write(0xF4);
  // Normal mode, temp and pressure over sampling rate = 1
  Wire.write(0x27);
  // Stop I2C Transmission
  Wire.endTransmission();

  // Start I2C Transmission
  Wire.beginTransmission(ADDR_I2C_BME280);
  // Select config register
  Wire.write(0xF5);
  // Stand_by time = 1000ms
  Wire.write(0xA0);
  // Stop I2C Transmission
  Wire.endTransmission();

  for (int i = 0; i < 8; i++)
  {
    // Start I2C Transmission
    Wire.beginTransmission(ADDR_I2C_BME280);
    // Select data register
    Wire.write((247 + i));
    // Stop I2C Transmission
    Wire.endTransmission();

    // Request 1 byte of data
    Wire.requestFrom(ADDR_I2C_BME280, 1);

    // Read 8 bytes of data
    if (Wire.available() == 1)
    {
      data[i] = Wire.read();
    }
  }

  // Convert pressure and temperature data to 19-bits
  long adc_p = (((long)(data[0] & 0xFF) * 65536) + ((long)(data[1] & 0xFF) * 256) + (long)(data[2] & 0xF0)) / 16;
  long adc_t = (((long)(data[3] & 0xFF) * 65536) + ((long)(data[4] & 0xFF) * 256) + (long)(data[5] & 0xF0)) / 16;
  // Convert the humidity data
  long adc_h = ((long)(data[6] & 0xFF) * 256 + (long)(data[7] & 0xFF));

  // Temperature offset calculations
  double var1 = (((double)adc_t) / 16384.0 - ((double)dig_T1) / 1024.0) * ((double)dig_T2);
  double var2 = ((((double)adc_t) / 131072.0 - ((double)dig_T1) / 8192.0) *
                 (((double)adc_t) / 131072.0 - ((double)dig_T1) / 8192.0)) *
                ((double)dig_T3);
  double t_fine = (long)(var1 + var2);
  double cTemp = (var1 + var2) / 5120.0;
  double fTemp = cTemp * 1.8 + 32;

  // Pressure offset calculations
  var1 = ((double)t_fine / 2.0) - 64000.0;
  var2 = var1 * var1 * ((double)dig_P6) / 32768.0;
  var2 = var2 + var1 * ((double)dig_P5) * 2.0;
  var2 = (var2 / 4.0) + (((double)dig_P4) * 65536.0);
  var1 = (((double)dig_P3) * var1 * var1 / 524288.0 + ((double)dig_P2) * var1) / 524288.0;
  var1 = (1.0 + var1 / 32768.0) * ((double)dig_P1);
  double p = 1048576.0 - (double)adc_p;
  p = (p - (var2 / 4096.0)) * 6250.0 / var1;
  var1 = ((double)dig_P9) * p * p / 2147483648.0;
  var2 = p * ((double)dig_P8) / 32768.0;
  double pressure = (p + (var1 + var2 + ((double)dig_P7)) / 16.0) / 100;

  // Humidity offset calculations
  double var_H = (((double)t_fine) - 76800.0);
  var_H = (adc_h - (dig_H4 * 64.0 + dig_H5 / 16384.0 * var_H)) * (dig_H2 / 65536.0 * (1.0 + dig_H6 / 67108864.0 * var_H * (1.0 + dig_H3 / 67108864.0 * var_H)));
  double humidity = var_H * (1.0 - dig_H1 * var_H / 524288.0);
  if (humidity > 100.0)
  {
    humidity = 100.0;
  }
  else if (humidity < 0.0)
  {
    humidity = 0.0;
  }

  // Output data to serial monitor

  // Serial.print("Temperature in Celsius : ");
  // Serial.print(cTemp);
  // Serial.println(" C");
  // Serial.print("Temperature in Fahrenheit : ");
  // Serial.print(fTemp);
  // Serial.println(" F");
  // Serial.print("Pressure : ");
  // Serial.print(pressure);
  // Serial.println(" hPa");
  // Serial.print("Relative Humidity : ");
  // Serial.print(humidity);
  // Serial.println(" RH");

  *fTc = (float)cTemp;
  *fTf = (float)fTemp;
  *fP = (float)pressure;
  *fRH = (float)humidity;

  return true;
}

bool bReadBME680(float *fTc, float *fGr, float *fP, float *fRH) {
  if (! bme.performReading()) {
    Serial.println("Failed to perform reading :(");
    return false;
  }
  //Serial.print("Temperature = ");
  //Serial.print(bme.temperature);
  //Serial.println(" *C");
  *fTc = bme.temperature;

  //Serial.print("Pressure = ");
  //Serial.print(bme.pressure / 100.0);
  //Serial.println(" hPa");
  *fP = bme.pressure;

  //Serial.print("Humidity = ");
  //Serial.print(bme.humidity);
  //Serial.println(" %");
  *fRH = bme.humidity;

  //Serial.print("Gas = ");
  //Serial.print(bme.gas_resistance / 1000.0);
  //Serial.println(" KOhms");
  *fGr = bme.gas_resistance;

  //Serial.print("Approx. Altitude = ");
  //Serial.print(bme.readAltitude(SEALEVELPRESSURE_HPA));
  //Serial.println(" m");
  //*fA = 100*bme.readAltitude(SEALEVELPRESSURE_HPA);

  return true;
}

void vPresentaValors(byte *by) {
  short int *si;

  if (by[32] & I2C_CONNECTED) {
    si = (short int *)&by[2]; Serial.print("T: "); Serial.print(float(*si) / 100); Serial.print("'C");
    si = (short int *)&by[0]; Serial.print(", RH: "); Serial.print(float(*si) / 100); Serial.print("%");
    si = (short int *)&by[4]; Serial.print(", P: "); Serial.print(*si); Serial.println("hPa");
  } else {
    Serial.println("BME not read");
  }
  if (by[32] & PM_CONNECTED) {
    si = (short int *)&by[6]; Serial.print("PM2.5: "); Serial.print(*si); Serial.print("ppm");
    si = (short int *)&by[8]; Serial.print(", PM10: "); Serial.print(*si); Serial.println("ppm");
  } else {
    Serial.println("PM not read");
  }
  if (by[32] & CO2_CONNECTED) {
    //si = (short int *)&by[12]; Serial.print("T: "); Serial.print(float(*si) / 10); Serial.print("'C");
    //si = (short int *)&by[10]; Serial.print(", RH: "); Serial.print(float(*si) / 10); Serial.print("%, ");
    si = (short int *)&by[14]; Serial.print("CO2: "); Serial.print(*si); Serial.println("ppm");
    sJson = "{ \"CO2_ppm\": "    + String(*si)
            //+ ", \"CO2_T\": "    + String(nTemp)
            + ", \"Llengua\": "  + "\"ca\""
            + "}";
  } else {
    sJson = "{ \"Llengua\":  \"ca\" }";
    Serial.println("CO2 not read");
  }
  if (by[32] & NOISE_CONNECTED) {
    si = (short int *)&by[16]; Serial.print("Noise: "); Serial.print(float(*si) / 10); Serial.println("dBA");
  } else {
    Serial.println("Noise not read");
  }
  if (by[32] & O3_CONNECTED) {
    si = (short int *)&by[20]; Serial.print("T: "); Serial.print(float(*si) / 10); Serial.print("'C");
    si = (short int *)&by[18]; Serial.print(", RH: "); Serial.print(float(*si) / 10); Serial.print("%");
    si = (short int *)&by[22]; Serial.print(", O3: "); Serial.print(float(*si) / 100); Serial.println("ppm");
  } else {
    Serial.println("O3 not read");
  }
  if (by[32] & NO2_CONNECTED) {
    si = (short int *)&by[26]; Serial.print("NO2: "); Serial.print(float(*si) / 100); Serial.println("ppm");
    //float fNO2 = ((float)((long int)((256*(long int)*(short int *)&by[24])+*(short int *)&by[26])))/100;
    //Serial.print("NO2: "); Serial.print(fNO2); Serial.println("ppm");
    //Serial.print("NO2 --> Word alt: 0x");Serial.print(*(short int *)&by[24],HEX);Serial.print("Word baix: 0x");Serial.println(*(short int *)&by[26],HEX);
  } else {
    Serial.println("NO2 not read");
  }
  if (by[32] & SO2_CONNECTED) {
    si = (short int *)&by[30]; Serial.print("SO2: "); Serial.print(float(*si) / 10); Serial.println("ppm");
    //float fSO2 =  ((float)((long int)((256*(long int)*(short int *)&by[28])+*(short int *)&by[30])))/10;
    //Serial.print("SO2: "); Serial.print(fSO2); Serial.println("ppm");
    //Serial.print("SO2 --> Word alt: 0x");Serial.print(*(short int *)&by[28],HEX);Serial.print("Word baix: 0x");Serial.println(*(short int *)&by[30],HEX);
  } else {
    Serial.println("SO2 not read");
  }
  for (int i = 0; i < LORA_DATA_LEN; i ++) {
    if (by[i] < 0x10) Serial.print("0");
    Serial.print(by[i], HEX); Serial.print(" ");
  }
  Serial.println();
}

void vGetSensorT(int nModBusAddr) {
  unsigned char ucLastRx[MAX_STR_LEN];
  int nQ;

  switch (nModBusAddr) {
    case 1: vPeticioModBus(MB_SENSOR_T_1); break;
    case 2: vPeticioModBus(MB_SENSOR_T_2); break;
    case 3: vPeticioModBus(MB_SENSOR_T_3); break;
    case 4: vPeticioModBus(MB_SENSOR_T_4); break;
    default: return;
  }
  vShowReceivedData(ucLastRx, nQ = nReceivingData(ucLastRx, TIMEOUT_ms));
  float fHR = fVector[(nModBusAddr - 1) * 2] = float(int(ucLastRx[3] * 256 + ucLastRx[4])) / 10;
  float fT = fVector[(nModBusAddr - 1) * 2 + 1]  = float(int(ucLastRx[5] * 256 + ucLastRx[6])) / 10;
#ifdef DEPURACIO
  Serial.print("Sensor "); Serial.print(nModBusAddr); Serial.print(") ");
  Serial.print("HR: "); Serial.print(fHR); Serial.print("%");
  Serial.print("     T: "); Serial.print(fT); Serial.println("ºC");
#endif

  switch (nModBusAddr) {
    case 1:
      sJson = "{ \"HR_1\": " + String(fHR) + ", \"T_1\": "  + String(fT);
      break;     
    case 2:
      sJson = "{ \"HR_2\": " + String(fHR) + ", \"T_2\": "  + String(fT);
      break;
    case 3:
      sJson += ", \"HR_3\": " + String(fHR) + ", \"T_3\": "  + String(fT);
      break;
    case 4:
      sJson += ", \"HR_4\": " + String(fHR) + ", \"T_4\": "  + String(fT);
      break;
    default: return;
  }
}

//void vGetSensorValues(enReadings enR) {
void vGetSensorValues(int n_enR) {
  unsigned char ucLastRx[MAX_STR_LEN];
  int nQ;
  float fTc, fGr, fP, fRH;
  enum enReadings {readBME, readPM, readCO2, readNoise, readO3, readNO2, readSO2};
  enReadings enR = (enReadings)n_enR;

  if (enR == readBME) {
    //if (bReadBME280(&fTc, &fTf, &fP, &fRH)) {
    if (bReadBME680(&fTc, &fGr, &fP, &fRH)) {
      vPutInt16((short int)(100 * fRH), bySensorsLoraData, 0);
      vPutInt16((short int)(100 * fTc), bySensorsLoraData, 2);
      vPutInt16((short int)(fP), bySensorsLoraData, 4);
      bySensorsLoraData[32] |= I2C_CONNECTED;
    } else {
      bySensorsLoraData[32] &= ~I2C_CONNECTED;
    }
  } else {
    if (enR == readSO2) {
      vPeticioModBus(MB_SENSOR_SO2);
    }
    if (enR == readNO2) {
      vPeticioModBus(MB_SENSOR_NO2);
    }
    if (enR == readO3) {
      vPeticioModBus(MB_SENSOR_O3);
    }
    if (enR == readNoise) {
      vPeticioModBus(MB_SENSOR_NOISE);
    }
    if (enR == readPM) {
      vPeticioModBus(MB_SENSOR_PM);
    }
    if (enR == readCO2) {
      vPeticioModBus(MB_SENSOR_CO2);
    }
    vShowReceivedData(ucLastRx, nQ = nReceivingData(ucLastRx, TIMEOUT_ms));
    Serial.print("nQ: "); Serial.println(nQ);
    if (enR == readPM) {
      if (nQ > 3) {
        vPutInt16(siBytes2shortInt(&ucLastRx[3]), bySensorsLoraData, 6);
        vPutInt16(siBytes2shortInt(&ucLastRx[5]), bySensorsLoraData, 8);
        bySensorsLoraData[32] |= PM_CONNECTED;// Marcar 1 bit PM
      } else {
        bySensorsLoraData[32] &= ~PM_CONNECTED;// Marcar 0 bit PM
      }
    }
    if (enR == readCO2) {
      if (nQ > 3) {
        vPutInt16(siBytes2shortInt(&ucLastRx[3]), bySensorsLoraData, 10);
        vPutInt16(siBytes2shortInt(&ucLastRx[5]), bySensorsLoraData, 12);
        vPutInt16(siBytes2shortInt(&ucLastRx[7]), bySensorsLoraData, 14);
        bySensorsLoraData[32] |= CO2_CONNECTED;// Marcar 1 bit CO2
      } else {
        bySensorsLoraData[32] &= ~CO2_CONNECTED;// Marcar 0 bit CO2
      }
    }
    if (enR == readNoise) {
      if (nQ > 3) {
        vPutInt16(siBytes2shortInt(&ucLastRx[3]), bySensorsLoraData, 16);
        bySensorsLoraData[32] |= NOISE_CONNECTED;// Marcar 1 bit Noise
      } else {
        bySensorsLoraData[32] &= ~NOISE_CONNECTED;// Marcar 0 bit Noise
      }
    }
    if (enR == readO3) {
      if (nQ > 3) {
        vPutInt16(siBytes2shortInt(&ucLastRx[3]), bySensorsLoraData, 18);
        vPutInt16(siBytes2shortInt(&ucLastRx[5]), bySensorsLoraData, 20);
        vPutInt16(siBytes2shortInt(&ucLastRx[7]), bySensorsLoraData, 22);
        bySensorsLoraData[32] |= O3_CONNECTED;// Marcar 1 bit O3
      } else {
        bySensorsLoraData[32] &= ~O3_CONNECTED;// Marcar 0 bit O3
      }
    }
    if (enR == readNO2) {
      if (nQ > 3) {
        vPutInt16(0, bySensorsLoraData, 24);
        vPutInt16(siBytes2shortInt(&ucLastRx[3]), bySensorsLoraData, 26);
        bySensorsLoraData[32] |= NO2_CONNECTED;// Marcar 1 bit NO2
      } else {
        bySensorsLoraData[32] &= ~NO2_CONNECTED;// Marcar 0 bit NO2
      }
    }
    if (enR == readSO2) {
      if (nQ > 3) {
        vPutInt16(0, bySensorsLoraData, 28);
        vPutInt16(siBytes2shortInt(&ucLastRx[3]), bySensorsLoraData, 30);
        bySensorsLoraData[32] |= SO2_CONNECTED;// Marcar 1 bit SO2
      } else {
        bySensorsLoraData[32] &= ~SO2_CONNECTED;// Marcar 0 bit SO2
      }
    }
  }
}

void LMICSaveVarsToRTC()
{
  Serial.println(F("Save LMIC to RTC ..."));
  RTC_LORAWAN_netid = LMIC.netid;
  RTC_LORAWAN_devaddr = LMIC.devaddr;
  memcpy(RTC_LORAWAN_nwkKey, LMIC.nwkKey, 16);
  memcpy(RTC_LORAWAN_artKey, LMIC.artKey, 16);
  RTC_LORAWAN_dn2Dr = LMIC.dn2Dr;
  RTC_LORAWAN_dnConf = LMIC.dnConf;
  RTC_LORAWAN_seqnoDn = LMIC.seqnoDn;
  RTC_LORAWAN_seqnoUp = LMIC.seqnoUp;
  RTC_LORAWAN_adrTxPow = LMIC.adrTxPow;
  RTC_LORAWAN_datarate = LMIC.datarate;
  RTC_LORAWAN_txChnl = LMIC.txChnl;
  RTC_LORAWAN_adrAckReq = LMIC.adrAckReq;
  //RTC_LORAWAN_rx1DrOffset = LMIC.rx1DrOffset;
  RTC_LORAWAN_rxDelay = LMIC.rxDelay;
  memcpy(RTC_LORAWAN_channelFreq, LMIC.channelFreq, MAX_CHANNELS * sizeof(u4_t));
  memcpy(RTC_LORAWAN_channelDrMap, LMIC.channelDrMap, MAX_CHANNELS * sizeof(u2_t));
  //memcpy(RTC_LORAWAN_channelDlFreq, LMIC.channelDlFreq, MAX_CHANNELS * sizeof(u4_t));
  memcpy(RTC_LORAWAN_bands, LMIC.bands, MAX_BANDS * sizeof(band_t));
  RTC_LORAWAN_channelMap = LMIC.channelMap;
}

void LMICLoadVarsFromRTC()
{
  Serial.println(F("Load LMIC vars from RTC ..."));
  LMIC_setSession(RTC_LORAWAN_netid, RTC_LORAWAN_devaddr, RTC_LORAWAN_nwkKey, RTC_LORAWAN_artKey);
  LMIC.dn2Dr = RTC_LORAWAN_dn2Dr;
  LMIC.dnConf = RTC_LORAWAN_dnConf;
  LMIC.seqnoDn = RTC_LORAWAN_seqnoDn;
  //LMIC_setSeqnoUp(RTC_LORAWAN_seqnoUp);
  LMIC.seqnoUp = RTC_LORAWAN_seqnoUp; //// !!!!
  LMIC_setDrTxpow(RTC_LORAWAN_datarate, RTC_LORAWAN_adrTxPow);
  LMIC.txChnl = RTC_LORAWAN_txChnl;
  LMIC.adrAckReq = RTC_LORAWAN_adrAckReq;
  //LMIC.rx1DrOffset = RTC_LORAWAN_rx1DrOffset;
  LMIC.rxDelay = RTC_LORAWAN_rxDelay;
  memcpy(LMIC.channelFreq, RTC_LORAWAN_channelFreq, MAX_CHANNELS * sizeof(u4_t));
  memcpy(LMIC.channelDrMap, RTC_LORAWAN_channelDrMap, MAX_CHANNELS * sizeof(u2_t));
  //memcpy(LMIC.channelDlFreq, RTC_LORAWAN_channelDlFreq, MAX_CHANNELS * sizeof(u4_t));
  memcpy(LMIC.bands, RTC_LORAWAN_bands, MAX_BANDS * sizeof(band_t));
  LMIC.channelMap = RTC_LORAWAN_channelMap;
}

void print_wakeup_reason() {
  esp_sleep_wakeup_cause_t wakeup_reason;

  wakeup_reason = esp_sleep_get_wakeup_cause();

  switch (wakeup_reason)
  {
    case 1 : Serial.println("Wakeup caused by external signal using RTC_IO"); break;
    case 2 : Serial.println("Wakeup caused by external signal using RTC_CNTL"); break;
    case 3 : Serial.println("Wakeup caused by timer"); break;
    case 4 : Serial.println("Wakeup caused by touchpad"); break;
    case 5 : Serial.println("Wakeup caused by ULP program"); break;
    default : Serial.println("Wakeup was not caused by deep sleep"); break;
  }
}

void onEvent (ev_t ev) {
  Serial.print(os_getTime());
  Serial.print(": ");
  switch (ev) {
    case EV_SCAN_TIMEOUT:
      Serial.println(F("EV_SCAN_TIMEOUT"));
      break;
    case EV_BEACON_FOUND:
      Serial.println(F("EV_BEACON_FOUND"));
      break;
    case EV_BEACON_MISSED:
      Serial.println(F("EV_BEACON_MISSED"));
      break;
    case EV_BEACON_TRACKED:
      Serial.println(F("EV_BEACON_TRACKED"));
      break;
    case EV_JOINING:
      Serial.println(F("EV_JOINING"));
      break;
    case EV_JOINED:
      Serial.println(F("EV_JOINED"));

      // Disable link check validation (automatically enabled
      // during join, but not supported by TTN at this time).
      LMIC_setLinkCheckMode(0);
      break;
    case EV_RFU1:
      Serial.println(F("EV_RFU1"));
      break;
    case EV_JOIN_FAILED:
      Serial.println(F("EV_JOIN_FAILED"));
      break;
    case EV_REJOIN_FAILED:
      Serial.println(F("EV_REJOIN_FAILED"));
      break;
      break;
    case EV_TXCOMPLETE:
      Serial.println(F("EV_TXCOMPLETE (includes waiting for RX windows)"));
      if (LMIC.txrxFlags & TXRX_ACK)
        Serial.println(F("Received ack"));
      if (LMIC.dataLen) {
        Serial.println(F("Received "));
        Serial.println(LMIC.dataLen);
        Serial.println(F(" bytes of payload"));
        for (int i = 0; i < LMIC.dataLen; i++) {
          if (LMIC.frame[LMIC.dataBeg + i] < 0x10) {
            Serial.print(F("0"));
          }
          Serial.print(LMIC.frame[LMIC.dataBeg + i], HEX);
          Serial.print(" ");
        }
        Serial.println();
      }
      GOTO_DEEPSLEEP = true;
      // Schedule next transmission
      os_setTimedCallback(&sendjob, os_getTime() + sec2osticks(TX_INTERVAL), do_send);
      break;
    case EV_LOST_TSYNC:
      Serial.println(F("EV_LOST_TSYNC"));
      break;
    case EV_RESET:
      Serial.println(F("EV_RESET"));
      break;
    case EV_RXCOMPLETE:
      // data received in ping slot
      Serial.println(F("EV_RXCOMPLETE"));
      break;
    case EV_LINK_DEAD:
      Serial.println(F("EV_LINK_DEAD"));
      break;
    case EV_LINK_ALIVE:
      Serial.println(F("EV_LINK_ALIVE"));
      break;
    default:
      Serial.println(F("Unknown event"));
      break;
  }
}

void do_send(osjob_t* j) {
  // Check if there is not a current TX/RX job running
  if (LMIC.opmode & OP_TXRXPEND) {
    Serial.println(F("OP_TXRXPEND, not sending"));
  } else {
    // Prepare upstream data transmission at the next possible time.
    // LMIC_setTxData2(1, mydata, sizeof(mydata) - 1, 0);
    for (int i = 0; i < 7; i++)
      vGetSensorValues(i); // enum enReadings {readBME, readPM, readCO2, readNoise, readO3, readNO2, readSO2};
    vPresentaValors(bySensorsLoraData);
    LMIC_setTxData2(1, bySensorsLoraData, LORA_DATA_LEN, 0);
    Serial.println(F("Packet queued"));
  }
  // Next TX is scheduled after TX_COMPLETE event.
}

void vSetupBME680() {
  if (!bme.begin()) {
    Serial.println("Could not find a valid BME680 sensor, check wiring!");
    while (1);
  }

  // Set up oversampling and filter initialization
  bme.setTemperatureOversampling(BME680_OS_8X);
  bme.setHumidityOversampling(BME680_OS_2X);
  bme.setPressureOversampling(BME680_OS_4X);
  bme.setIIRFilterSize(BME680_FILTER_SIZE_3);
  bme.setGasHeater(320, 150); // 320*C for 150 ms;
}

void setup() {
  Serial.begin(115200);
  modbusData.begin(4800);          // U2_RXD:GPIO16, U2_TXD:GPIO17 (UART2)
  pinMode(SSerialTxControl, OUTPUT); // hardwired to GPIO_5. In CAH is hardwired to GPIO_33
  vModeTxRxRS485(RS485Receive);
  bySensorsLoraData[32] = 0x00;
  Wire.begin();
  vSetupScreen();
  Serial.println(__FILE__);
  Serial.println(F("Starting"));

#ifdef VCC_ENABLE
  // For Pinoccio Scout boards
  pinMode(VCC_ENABLE, OUTPUT);
  digitalWrite(VCC_ENABLE, HIGH);
  delay(1000);
#endif

  ++bootCount;
  Serial.println("Boot number: " + String(bootCount));

  //Print the wakeup reason for ESP32
  print_wakeup_reason();

  esp_sleep_enable_timer_wakeup(TIME_TO_SLEEP * uS_TO_S_FACTOR);
  Serial.println("Setup ESP32 to sleep for every " + String(TIME_TO_SLEEP) + " Seconds");
  /*
    // LMIC init
    SPI.begin(SCK_GPIO, MISO_GPIO, MOSI_GPIO, NSS_GPIO);
    os_init();
    // Reset the MAC state. Session and pending data transfers will be discarded.
    LMIC_reset();
    // Load the LoRa information from RTC
    if (RTC_LORAWAN_seqnoUp != 0) {
      LMICLoadVarsFromRTC();
    }
    if (bootCount < 2) {
      Serial.println("El primer cop m'espero 30 segons per a estabilitzar els valor llegits dels sensors.");
      delay(30000);
    }

    // Start job (sending automatically starts OTAA too)
    do_send(&sendjob);
  */
  // vSetupBME680();
  // En producció s'haurà de posar la part d' "El primer cop m'espero 30 segons per a estabilitzar els valor llegits dels sensors."

#ifdef USING_WIFI
  //if (digitalRead(SW3)) {
  xTaskCreatePinnedToCore(
    vConnectingMqttsTask,    /* Task function. */
    "Connecting MQTTS Task", /* name of task. */
    //10000,                   /* Stack size of task */
    8192,  /* Stack size of task */
    NULL,  /* parameter of the task */
    2,     /* priority of the task */
    NULL,
    ARDUINO_RUNNING_CORE);
  //}
#endif         /* USING_WIFI */
}

void loop() {
  static long int nCmpt = 0;
  static unsigned long n = 0;
  int i;

  for (i = 1; i < 2; i++) {
#ifdef DEPURACIO
    Serial.print("Sensor "); Serial.print(i); Serial.println(":");
#endif
    vGetSensorT(i);
    delay(100);
  }
  sJson += " }";
  Serial.print(nCmpt++); Serial.print(") "); Serial.println(sJson);

  vRhT(fVector);

#ifdef DEPURACIO
  Serial.println("Vector: ");
  for (i = 0 ; i < 6 ; i++) {
    Serial.print(fVector[i]); Serial.print(" ");
  }
  Serial.println();
#endif

  n++;
  if (n > INTERVAL_MISSATGES_MQTT_EN_SEGONS) {
    if (bMqttsConnectat) {
      Serial.print("Tema: "); Serial.println(String("/" + String(sMac) + TOPIC_JSON_DATA).c_str());
      Serial.print("Contingut: "); Serial.println(sJson.c_str());
      client.publish( String("/" + String(sMac) + TOPIC_JSON_DATA).c_str(), sJson.c_str());

    } else {
      Serial.print("No hi ha WiFi. El json seria: "); //Serial.println(sJson);
    }
    n = 0;
  }

  /*
    static unsigned long n = 0;
    // os_runloop_once();

    for (int i = 0; i < 7; i++)
    vGetSensorValues(i); // enum enReadings {readBME, readPM, readCO2, readNoise, readO3, readNO2, readSO2};
    //vPresentaValors(bySensorsLoraData);

    delay(1000);

    n++;
    if (n > INTERVAL_MISSATGES_MQTT_EN_SEGONS) {
    if (bMqttsConnectat) {
      vPresentaValors(bySensorsLoraData); // Lectura del CO2 i incorporat  sJson
      Serial.print("Tema: "); Serial.println(String("/" + String(sMac) + TOPIC_JSON_DATA).c_str());
      Serial.print("Contingut: "); Serial.println(sJson.c_str());
      client.publish( String("/" + String(sMac) + TOPIC_JSON_DATA).c_str(), sJson.c_str());

    } else {
      Serial.print("No hi ha WiFi. El json seria: "); //Serial.println(sJson);
    }
    n = 0;
    }


    if (GOTO_DEEPSLEEP == true)
    {
    // //esp_sleep_enable_timer_wakeup(seconds * 1000000);
    // LMICSaveVarsToRTC();
    Serial.println("Going to sleep now");
    esp_deep_sleep_start();
    }
  */
}
