#include "IoT-02_oled.h"


void vSetupScreen() {
  display.init();
  display.flipScreenVertically();
}


void vScreen10pixelText(int x, int y, String szText) {
  display.clear();
  // create more fonts at http://oleddisplay.squix.ch/
  display.setTextAlignment(TEXT_ALIGN_LEFT);
  display.setFont(ArialMT_Plain_10);
  display.drawString(x, y, szText);
  display.display();
}

void vScreen16pixelText(int x, int y, String szText) {
  display.clear();
  // create more fonts at http://oleddisplay.squix.ch/
  display.setTextAlignment(TEXT_ALIGN_LEFT);
  display.setFont(ArialMT_Plain_16);
  display.drawString(x, y, szText);
  display.display();
}

void vScreen24pixelText(int x, int y, String szText) {
  display.clear();
  // create more fonts at http://oleddisplay.squix.ch/
  display.setTextAlignment(TEXT_ALIGN_LEFT);
  display.setFont(ArialMT_Plain_24);
  display.drawString(x, y, szText);
  display.display();
}

void vRhT(float *fV) {
  display.clear();
  // create more fonts at http://oleddisplay.squix.ch/
  display.setTextAlignment(TEXT_ALIGN_LEFT);
  display.setFont(ArialMT_Plain_16);
  /*
  display.drawString(0, 0, "H: "+String(int(fV[0]))+"% T: "+String(fV[1],1)+"ºC");
  display.drawString(0, 20, "H: "+String(int(fV[2]))+"% T: "+String(fV[3],1)+"ºC");
  display.drawString(0, 40, "H: "+String(int(fV[4]))+"% T: "+String(fV[5],1)+"ºC");
  */
  display.drawString(0, 20, "H: "+String(int(fV[0]))+"% T: "+String(fV[1],1)+"ºC");
  
  display.display();
}
